#Manage EXP
scoreboard players operation @s[tag=!was_trinket_activated] waypoint_exp = @s CatalystMax
scoreboard players operation @s[tag=was_trinket_activated] waypoint_exp = @s CatalystXP
scoreboard players add @s[tag=was_trinket_activated] waypoint_exp 20



#Save Position
function link:system/catalyst/setid

#Save Data In Storage

# == world position
execute store result storage macro:waypoint tp.X int 1 run data get entity @s Pos[0] 100
execute store result storage macro:waypoint tp.Y int 1 run data get entity @s Pos[1] 100
execute store result storage macro:waypoint tp.Z int 1 run data get entity @s Pos[2] 100
execute store result storage macro:waypoint tp.W int 1 run scoreboard players get @s W

# == world position to scale
execute store result storage macro:waypoint tp.posX int 1 run data get entity @s Pos[0] 1
execute store result storage macro:waypoint tp.posY int 1 run data get entity @s Pos[1] 1
execute store result storage macro:waypoint tp.posZ int 1 run data get entity @s Pos[2] 1


# == experience
execute store result storage macro:waypoint tp.Exp int 1 run scoreboard players get @s waypoint_exp

# == dimension name (0 : overworld, -1 : nether , 1 : end )

execute if score @s W matches 0 run data modify storage macro:waypoint tp.name set value '{"translate":link.item.teleporter_overworld.name,"color":"light_purple","italic":false}'
execute if score @s W matches 0 run data modify storage macro:waypoint tp.model set value 9

execute if score @s W matches -1 run data modify storage macro:waypoint tp.name set value '{"translate":link.item.teleporter_nether.name,"color":"light_purple","italic":false}'
execute if score @s W matches -1 run data modify storage macro:waypoint tp.model set value 10

execute if score @s W matches 1 run data modify storage macro:waypoint tp.name set value '{"translate":link.item.teleporter_end.name,"color":"light_purple","italic":false}'
execute if score @s W matches 1 run data modify storage macro:waypoint tp.model set value 11

# SPAWN ITEM

function link:system/catalyst/create with storage macro:waypoint tp
data remove storage macro:waypoint tp


teleport @e[tag=created,limit=1,sort=nearest] @p[distance=..6]

execute as @p[distance=..6] at @s run function link:system/catalyst/player_trigger

execute if score @s CatalystMax matches 200.. run scoreboard players add @p[distance=..6] rank_points 10

tag @e[tag=created,limit=1,sort=nearest] remove created


playsound minecraft:block.ender_chest.open block @a ~ ~ ~ 0.4 0.2 0
playsound minecraft:block.respawn_anchor.deplete block @a ~ ~ ~ 0.5 2 0
particle minecraft:dragon_breath ~ ~ ~ 0.5 0.2 0.5 0.05 40

function link:system/catalyst/deactivate